=== debian/changelog ===
freefem++ (3.20-1) experimental; urgency=low

  * New upstream release.
  * Add libnlopt-dev and coinor-libipopt-dev to build-deps.
  * Update patch examples++-load-Makefile.patch.
  * Remove patch examples-load-WHERE-LIBRARY.patch.

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Thu, 18 Oct 2012 14:14:12 +0300
